
'%MAKEDLL = 1
'
'#If %MAKEDLL = 1
'   #Compile Dll "xmlExcel.dll"
'#Else
   #Compile Sll "xmlExcel.sll"
'#endif

Macro PropGet(PropName,PropType)=Property Get PropName() As PropType:Property=PropName:End Property
Macro PropSet(PropName,PropType)=Property Set PropName(ByVal param As PropType):PropName=param:End Property
Macro PropGetSet(PropName,PropType)=PropGet(PropName,PropType):PropSet(PropName,PropType)

#Include "windows.inc"
#Include "afxWin.inc"

#Include Once "clsWorkSheet.inc"
#Include Once "clsWorkSheetCell.inc"


Class clsExcelWorkBook Common
   Instance iWorkSheets()     As iExcelWorkSheet
   Instance iStyleDefault     As iExcelCell  ' holds the default style
   Instance iStyles()         As iExcelCell  ' holds all other workbook styles
   
   Instance m_nWorkSheetCount As Long 
   Instance Filename          As String
   Instance Author            As String
   Instance Company           As String
   Instance Version           As Single
   Instance m_NextStyleIndex  As Dword
   
   
   '//
   '//
   '//
   Class Method Create()
      Dim iWorkSheets(0) As Instance iExcelWorkSheet
      Dim iStyles(0)     As Instance iExcelCell
      
      Let iStyleDefault = Class "clsExcelCell"

      Version = 1.02   ' version of our xml class
      
      iStyleDefault.FontName      = "Calibri"
      iStyleDefault.FontSize      = 11
      iStyleDefault.FontBold      = 0
      iStyleDefault.FontUnderline = 0
      iStyleDefault.FontItalic    = 0
      iStyleDefault.FontColor     = "#000000"
      iStyleDefault.IsDefaultStyle = 1  ' true
      
      'iStyleDefault.Value = "DEFAULT STYLE"
      
      m_nWorkSheetCount = 0
      m_NextStyleIndex  = 0
      
   End Method

   '//
   '//
   '//
   Class Method Destroy()
      Let iStyleDefault = Nothing
      Erase iWorkSheets()  ' this will call the clsWorkSheet DESTROY for each spreadsheet
      Erase iStyles()
   End Method
   
   
   '//
   '//
   '//
   Interface iExcelWorkBook: Inherit IUnknown     
      
      PropGet(Version, Single)
      PropGetSet(Filename, String)
      PropGetSet(Author, String)
      PropGetSet(Company, String)
      
      Property Get DefaultFontName() As String
         Property = iStyleDefault.FontName
      End Property
      
      Property Set DefaultFontName( ByVal sFontName As String )
         iStyleDefault.FontName = sFontName
      End Property
      
      Property Get DefaultFontSize() As Long
         Property = iStyleDefault.FontSize
      End Property
      
      Property Set DefaultFontSize( ByVal nFontSize As Long )
         iStyleDefault.FontSize = nFontSize
      End Property
            
      Property Get DefaultFontBold() As Long
         Property = iStyleDefault.FontBold
      End Property
      
      Property Set DefaultFontBold( ByVal nFontBold As Long )
         iStyleDefault.FontBold = nFontBold
      End Property

      Property Get DefaultFontUnderline() As Long
         Property = iStyleDefault.FontUnderline
      End Property
      
      Property Set DefaultFontUnderline( ByVal nFontUnderline As Long )
         iStyleDefault.FontUnderline = nFontUnderline
      End Property

      Property Get DefaultFontColor() As String
         Property = iStyleDefault.FontColor
      End Property
      
      Property Set DefaultFontColor( ByVal sFontColor As String )
         iStyleDefault.FontColor = sFontColor
      End Property
      
      
      Method CompareStyles( ByRef iStyle1 As iExcelCell, _
                            ByRef iStyle2 As iExcelCell _
                            ) As Long

'? "iStyle1 Row:Col  " & Format$(iStyle1.Row) & ":" & Format$(iStyle1.Col) & $CrLf & _ 
'  "  Value: " & Variant$(iStyle1.Value) & $CrLf & _
'  "  Bold:" & Str$(iStyle1.FontBold) & " Underline:" & Str$(iStyle1.FontUnderline) & $CrLf & _
'  "  Italic:" & Str$(iStyle1.FontItalic) & " Size:" & Str$(iStyle1.FontSize) & $CrLf & _
'  "  Name: " & iStyle1.FontName & "   Color: " & iStyle1.FontColor & $CrLf & _
'  "  StyleIndex: " & Str$(iStyle1.StyleIndex) & "   DuplicateStyle:" & Str$(iStyle1.DuplicateStyle) & $CrLf & _
'  "  FontMatched: " & Str$(iStyle1.FontMatched) & $CrLf & _
'  $CrLf & _
'  "iStyle2 Row:Col  " & Format$(iStyle2.Row) & ":" & Format$(iStyle2.Col) & $CrLf & _
'  "  Value: " & Variant$(iStyle2.Value) & $CrLf & _
'  "  Bold:" & Str$(iStyle2.FontBold) & " Underline:" & Str$(iStyle2.FontUnderline) & $CrLf & _
'  "  Italic:" & Str$(iStyle2.FontItalic) & " Size:" & Str$(iStyle2.FontSize) & $CrLf & _
'  "  Name: " & iStyle2.FontName & "   Color: " & iStyle2.FontColor & $CrLf & _
'  "  StyleIndex: " & Str$(iStyle2.StyleIndex) & "   DuplicateStyle:" & Str$(iStyle2.DuplicateStyle)  & $CrLf & _
'  "  FontMatched: " & Str$(iStyle2.FontMatched)
  

                            
         ' Start with the numeric comparison checks first because 
         ' they would be faster than the string compares.
         If iStyle1.FontName = iStyle2.FontName Then
            If iStyle1.FontSize = iStyle2.FontSize Then
               If iStyle1.FontColor = iStyle2.FontColor Then
                  ' Set flag for this cell/style that the Font matched
                  ' the default font. This enables us to bypass having to 
                  ' output the text for these elements in our new styles xml.
                  If Istrue(iStyle2.IsDefaultStyle) Then
                     iStyle1.FontMatched = 1
                  End If   
               End If
            End If
         End If         


         ' No need to keep testing if the Font hasn't even matched.
         If IsFalse(iStyle1.FontMatched) Then Exit Method

         If iStyle1.FontBold      <> iStyle2.FontBold      Then Exit Method
         If iStyle1.FontUnderline <> iStyle2.FontUnderline Then Exit Method
         If iStyle1.FontItalic    <> iStyle2.FontItalic    Then Exit Method
         If iStyle1.CellColor     <> iStyle2.CellColor     Then Exit Method
         If iStyle1.BorderLeft    <> iStyle2.BorderLeft    Then Exit Method
         If iStyle1.BorderTop     <> iStyle2.BorderTop     Then Exit Method
         If iStyle1.BorderRight   <> iStyle2.BorderRight   Then Exit Method
         If iStyle1.BorderBottom  <> iStyle2.BorderBottom  Then Exit Method
         If iStyle1.BorderColor   <> iStyle2.BorderColor   Then Exit Method
         If iStyle1.AlignLeft     <> iStyle2.AlignLeft     Then Exit Method
         If iStyle1.AlignRight    <> iStyle2.AlignRight    Then Exit Method
         If iStyle1.AlignCenter   <> iStyle2.AlignCenter   Then Exit Method
         If iStyle1.Format        <> iStyle2.Format        Then Exit Method
         If iStyle1.WrapText      <> iStyle2.WrapText      Then Exit Method
         
         ' If we get this far then we must have a match
         Method = 1
                            
      End Method                      
      
      
      Method SearchForStyleMatch( ByRef iStyle As iExcelCell ) As Long
      
         Local iStyleSearch As iExcelCell
         Local i, y         As Long
         Local nCellCount   As Long
         
         ' Before searching all other cells for a matching style, check
         ' the more obvious match being the default style. If the incoming
         ' style does not have any defaults assigned yet then we need to
         ' do that first.
         If Len(iStyle.FontName)  = 0 Then iStyle.FontName  = iStyleDefault.FontName
         If Len(iStyle.FontColor) = 0 Then iStyle.FontColor = iStyleDefault.FontColor    
         If iStyle.FontSize       = 0 Then iStyle.FontSize  = iStyleDefault.FontSize      
               
         If IsTrue( Me.CompareStyles(iStyle, iStyleDefault) ) Then
            iStyle.StyleIndex = 0
            Exit Method
         End If   
         
         ' Search our existing already defined styles for a match. Return the matching
         ' style index number if it exists, otherwise create a new style and return
         ' that index number.
         For i = 1 To m_NextStyleIndex
            iStyleSearch = iStyles(i) 
            If IsTrue( Me.CompareStyles(iStyle, iStyleSearch) ) Then
               iStyle.StyleIndex = iStyleSearch.StyleIndex 
               Exit Method
            End If
         Next
         
         ' If we get this far then the style was not matched by the default
         ' or any other already defined cell style. Therefore, this cell will
         ' now represent a style that we have to define in our Workbook.
         Incr m_NextStyleIndex 
         
         ' Add the new style to the collection
         If m_NextStyleIndex > UBound(iStyles) Then
            ReDim Preserve iStyles(m_NextStyleIndex) As Instance iExcelCell
         End If

         iStyles(m_NextStyleIndex) = Class "clsExcelCell"
         iStyles(m_NextStyleIndex) = iStyle
          
         iStyle.StyleIndex = m_NextStyleIndex  
         
      End Method
      
      
      Method GenerateStyleIndexes() As Long
         ' Need to iterate the cells array to determine if the style
         ' already exists. If it does then return the index of the
         ' cell, otherwise add the new style and return that index. 
         Local iStyle     As iExcelCell
         Local i, y       As Long
         Local nCellCount As Long
         
         For i = 1 To m_nWorkSheetCount 
            
            nCellCount = iWorkSheets(i).CellCount
            
            For y = 1 To nCellCount
               iStyle = iWorkSheets(i).GetCellObject(y)
               
               ' Find out if the style for this cell matches one already
               ' defined in a previous cell (or matches the default style).
               ' The default style match is 0.
               Me.SearchForStyleMatch( iStyle )
               
               afxDoEvents(0)
               
            Next 
            
         Next
         
      End Method
         
      
      Method AddWorkSheet( ByVal SheetName As String ) As iExcelWorkSheet

         ' Add the new worksheet to the collection
         Incr m_nWorkSheetCount
         If m_nWorkSheetCount > UBound(iWorkSheets) Then
            ReDim Preserve iWorkSheets(m_nWorkSheetCount) As Instance iExcelWorkSheet
         End If

         iWorkSheets(m_nWorkSheetCount) = Class "clsExcelWorkSheet"
         iWorkSheets(m_nWorkSheetCount).SheetName = SheetName
         
         Method = iWorkSheets(m_nWorkSheetCount)

      End Method
      
      
      Method WriteXML()
         
         Local st             As String
         Local f, i, y        As Long
         Local sXML           As String
         Local sStyles        As String
         Local sDate          As String    
         Local sStyle         As String
         Local nCellCount     As Long
         Local iStyle         As iExcelCell
   
         
         If Len(Filename) = 0 Then
            ' raise error
            Exit Method
         End If
            
         sXML = _
              "<?xml version=*1.0*?>"                                          & $CrLf & _
              "<?mso-application progid=*Excel.Sheet*?>"                       & $CrLf & _
              "<Workbook xmlns=*urn:schemas-microsoft-com:office:spreadsheet*" & $CrLf & _
              " xmlns:o=*urn:schemas-microsoft-com:office:office*"             & $CrLf & _
              " xmlns:x=*urn:schemas-microsoft-com:office:excel*"              & $CrLf & _
              " xmlns:ss=*urn:schemas-microsoft-com:office:spreadsheet*"       & $CrLf & _
              " xmlns:html=*http://www.w3.org/TR/REC-html40*>"                 & $CrLf & _
              "<DocumentProperties xmlns=*urn:schemas-microsoft-com:office:office*>" & $CrLf & _
              " <Author>//AUTHOR//</Author>"                         & $CrLf & _
              " <LastAuthor>//AUTHOR//</LastAuthor>"                 & $CrLf & _
              " <Created>//DATE_CREATED//T00:00:00Z</Created>"       & $CrLf & _
              " <LastSaved>//DATE_CREATED//T00:00:00Z</LastSaved>"   & $CrLf & _
              " <Company>//COMPANY//</Company>"              & $CrLf & _
              " <Version>14.00</Version>"                    & $CrLf & _
              "</DocumentProperties>"                        & $CrLf & _
              "<OfficeDocumentSettings xmlns=*urn:schemas-microsoft-com:office:office*>" & $CrLf & _
              " <AllowPNG/>"                                 & $CrLf & _
              "</OfficeDocumentSettings>"                    & $CrLf & _
              "<ExcelWorkbook xmlns=*urn:schemas-microsoft-com:office:excel*>" & $CrLf & _
              " <WindowHeight>7416</WindowHeight>"           & $CrLf & _
              " <WindowWidth>17220</WindowWidth>"            & $CrLf & _
              " <WindowTopX>0</WindowTopX>"                  & $CrLf & _
              " <WindowTopY>48</WindowTopY>"                 & $CrLf & _
              " <ProtectStructure>False</ProtectStructure>"  & $CrLf & _
              " <ProtectWindows>False</ProtectWindows>"      & $CrLf & _
              "</ExcelWorkbook>"                             & $CrLf 
         Replace "*" With $Dq In sXML            
         
         sDate = Right$(Date$,4) & "-" & Left$(Date$, 5)
         
   
         ' Create the string to write to the file
         
         Replace "//AUTHOR//"         With Author     In sXML
         Replace "//COMPANY//"        With Company    In sXML
         Replace "//DATE_CREATED//"   With sDate      In sXML

         
         ' Write the final Excel file
         If Dir$(Filename) > "" Then Kill Filename
         f = FreeFile
         Open Filename For Append As #f

         ' Generate code for all of the Worksheets in the Workbook. As each
         ' cell in each Worksheet is processed, a style can be created or
         ' an existing style used. That's why we wait to create the xml for
         ' styles until after the Worksheets are processed. The Styles are
         ' global to all Worksheets.
         Me.GenerateStyleIndexes

         Local iStringStyles As IStringBuilderA
         iStringStyles = Class "StringBuilderA"
         iStringStyles.Capacity = 1024 * 64   '(64K character buffer)
         iStringStyles.Add "<Styles>" & $CrLf 
         
         sStyle = _
           " <Style ss:ID=*Default* ss:Name=*Normal*>"    & $CrLf & _
           "  <Alignment ss:Vertical=*Bottom*/>"          & $CrLf & _
           "  <Borders/>"                                 & $CrLf & _
           "  <Font" & _
             IIf$(Len(iStyleDefault.FontName),         " ss:FontName=*" & iStyleDefault.FontName & "*", "") & _
             IIf$(iStyleDefault.FontSize > 0,          " ss:Size=*" & Format$(iStyleDefault.FontSize) & "*", "") & _
             IIf$(Len(iStyleDefault.FontColor),        " ss:Color=*" & iStyleDefault.FontColor & "*", "")  & _
             IIf$(IsTrue(iStyleDefault.FontBold),      " ss:Bold=*1*", "")           & _
             IIf$(IsTrue(iStyleDefault.FontItalic),    " ss:Italic=*1*", "")         & _
             IIf$(IsTrue(iStyleDefault.FontUnderline), " ss:Underline=*Single*", "") & _
             "/>" & $CrLf & _
           "  <Interior/>"                                & $CrLf & _
           "  <NumberFormat/>"                            & $CrLf & _
           "  <Protection/>"                              & $CrLf & _
           " </Style>"                                    & $CrLf 
         
         Replace "*" With $Dq In sStyle 
         iStringStyles.Add sStyle
            
         
         For i = 1 To m_NextStyleIndex 
            If IsObject(iStyles(i)) Then   
               sStyle = _
                 " <Style " & "ss:ID=" & $Dq & "s" & Format$(iStyles(i).StyleIndex) & $Dq & ">"  & $CrLf & _
                      iStyles(i).StyleXML              & _
                 " </Style>"                           & $CrLf 
               iStringStyles.Add sStyle
            End If
         Next

         iStringStyles.Add "</Styles>" & $CrLf
         

         ' Output the main header and styles to the final file
         Print #f, sXML
         Print #f, iStringStyles.String 

         Let iStringStyles = Nothing

         
         ' Generate output for each Worksheet in the Workbook
         For i = 1 To m_nWorkSheetCount
            afxDoEvents(0)
            Print #f, iWorkSheets(i).WorkSheetXML 
            Print #f, ""
         Next
         Print #f, "</Workbook>" & $CrLf
         
         Close #f
'Profile "_debug.txt"
         
      End Method
      
      
   End Interface
   
End Class
      



                