

Class clsExcelWorkSheet Common
   Instance SheetName    As String
   Instance iCellIndex() As Quad
   Instance iCellArray() As iExcelCell
   Instance CellCount    As Long
   Instance m_nGrowAmt   As Long                          
   
   Instance ColumnWidths() As Single
   Instance BitArray()     As Dword   

   Instance PageMarginHeader     As Single
   Instance PageMarginFooter     As Single
   Instance PageMarginTop        As Single
   Instance PageMarginLeft       As Single
   Instance PageMarginRight      As Single
   Instance PageMarginBottom     As Single
   Instance PageCenterVertical   As Long
   Instance PageCenterHorizontal As Long
   Instance PageLandscape        As Long
   Instance PagePortrait         As Long
   Instance DefaultRowHeight     As Single
   Instance FitToPage            As Long 
   
   
   '//
   '//
   '//
   Class Method Create()

      m_nGrowAmt = 100

      ' Initialize the cell arrays
      Dim iCellIndex(1 To m_nGrowAmt) As Instance Quad
      Dim iCellArray(1 To m_nGrowAmt) As Instance iExcelCell
      Dim ColumnWidths(1 To 1000)     As Instance Single
      Dim BitArray(1 To 500000)       As Instance Dword   ' 2 million bits (0 to 1999999)

      PageMarginHeader     = 0.3
      PageMarginFooter     = 0.3
      PageMarginTop        = 0.75
      PageMarginLeft       = 0.7
      PageMarginRight      = 0.7
      PageMarginBottom     = 0.75
      PageCenterVertical   = 0
      PageCenterHorizontal = 0
      PagePortrait         = 1
      PageLandscape        = 0
      DefaultRowHeight     = 14.55
      FitToPage            = 0
      
      CellCount = 0

   End Method


   Class Method DESTROY()  
      Erase iCellIndex()
      Erase iCellArray()
      Erase ColumnWidths()
      Erase BitArray()
   End Method


   '//
   '//
   '//
   Interface iExcelWorksheet: Inherit IUnknown

      PropGetSet(SheetName, String)
      PropGetSet(PageMarginHeader, Single)
      PropGetSet(PageMarginFooter, Single)
      PropGetSet(PageMarginTop, Single)
      PropGetSet(PageMarginLeft, Single)
      PropGetSet(PageMarginRight, Single)
      PropGetSet(PageMarginBottom, Single)
      PropGetSet(PageCenterVertical, Long)
      PropGetSet(PageCenterHorizontal, Long)
      PropGetSet(PageLandscape, Long)
      PropGetSet(PagePortrait, Long)
      PropGetSet(FitToPage, Long)
      PropGetSet(DefaultRowHeight, Single)
      PropGet(CellCount, Long)

      
      Method GetColumnWidth( ByVal nColNum As Long ) As Single
         If (nColNum >= LBound(ColumnWidths)) And (nColNum <= UBound(ColumnWidths)) Then
            Method = ColumnWidths(nColNum)
         End If    
      End Method
      
      Method SetColumnWidth( ByVal nColNum As Long, ByVal nColWidth As Single ) 
         If (nColNum >= LBound(ColumnWidths)) And (nColNum <= UBound(ColumnWidths)) Then
            ColumnWidths(nColNum) = nColWidth
         End If    
      End Method
      
      
      Method GetCell( ByVal nRow As Long, _
                      ByVal nCol As Long _
                      ) As iExcelCell
                            
         ' Retrieve a reference to a previously created cell (called externally)
         
         Local iCell As iExcelCell
         Local i     As Long

         For i = LBound(iCellIndex) To UBound(iCellIndex)
            iCell = iCellArray(i) 
            If (iCell.Row = nRow) Then
               If (iCell.Col = nCol) Then
                  Method = iCellArray(i)
                  Exit Method                 
               End If
            End If      
         Next

      End Method
      

                            
      Method GetCellObject( ByVal nIndex As Long ) As iExcelCell
         ' This method is used internally by the SLL
         Method = iCellArray(nIndex)
      End Method
      
                            
      Method AddCell( ByVal nRow   As Long, _
                      ByVal nCol   As Long, _
                      ByVal vValue As Variant _
                      ) As iExcelCell

         ' ADDING THOUSANDS OF CELLS TO A POWERCOLLECTION IS EXTREMELY SLOW!!!!!
         ' USE THE ARRAY METHODS INSTEAD.

         Local iIndex      As Quad    ' max of 1,000,000 rows and 1,000 columns
         Local iIndexSmall As Quad    ' 20,000 rows and 100 cols
         Local i           As Long
         Local iCell       As iExcelCell

         ' Add the new cell to the collection
         ' Maximum rows is 1000000 and columns 1000. Therefore, construct a
         ' key based on these maximum values.
         iIndex = (nRow * 1000) + nCol
         iIndexSmall = (nRow * 100) + nCol   ' to search if cell already exists
         
         ' Search the array to see of the cell already exists, otherwise add a new one.
         ' This takes way too long for large arrays.
         ' Use a bit array instead to look up cells within the 20,000 rows and 100 columns
         ' range (2 million bits). This should be efficient for most moderately sized spreadsheets.
         ' If the bit array indicates that the cell already exists then do the search
         ' and return the existing cell reference.
         If (iIndexSmall < UBound(BitArray) * 4) Then
            If IsTrue(Bit(BitArray(1), iIndexSmall)) Then
               For i = LBound(iCellIndex) To UBound(iCellIndex)
                  iCell = Me.GetCellObject(i) 
                  If (iCell.Row = nRow) Then
                     If (iCell.Col = nCol) Then
                        iCellArray(i).Value = vValue
                        Method = iCellArray(i)
                        Exit Method                 
                     End If
                  End If      
               Next
            End If   
            Bit Set BitArray(1), iIndexSmall
         End If   

         ' Must not have found an existing cell so add a new one.
         Incr CellCount

         If CellCount > UBound(iCellArray) Then
            ReDim Preserve iCellIndex(1 To CellCount + m_nGrowAmt) As Instance Quad
            ReDim Preserve iCellArray(1 To CellCount + m_nGrowAmt) As Instance iExcelCell
         End If

         iCellIndex(CellCount) = iIndex
         iCellArray(CellCount) = Class "clsExcelCell"
         iCellArray(CellCount).Row   = nRow
         iCellArray(CellCount).Col   = nCol
         iCellArray(CellCount).Value = vValue
            
         Method = iCellArray(CellCount)

      End Method


      Property Get WorkSheetXML() As String
         Local nRows       As Long
         Local nCols       As Long
         Local nPrevRow    As Long
         Local nPrevCol    As Long
         Local nNextRow    As Long
         Local st          As String
         Local sRow        As String
         Local sWorksheet  As String
         Local sLayout     As String
         Local sOptions    As String
         Local sRowMaster  As String
         Local nCurRow     As Long
         Local nCurCol     As Long
         Local IsLastRow   As Long 
         Local i           As Long

         sWorksheet = _
             "<Worksheet ss:Name=*//SHEET_NAME//*>"            & $CrLf & _
             " <Table ss:ExpandedColumnCount=*//COLUMN_COUNT//* ss:ExpandedRowCount=*//ROW_COUNT//* x:FullColumns=*1*" & $CrLf & _
             "  x:FullRows=*1* ss:DefaultRowHeight=*" & Format$(Me.DefaultRowHeight, "0.00") & "*>"   & $CrLf & _
             "//COLUMN_WIDTHS//"                               & _
             "//ALL_ROWS//"                                    & _
             " </Table>"                                       & $CrLf & _
             "//WORKSHEET_OPTIONS//"                           & _         
             "</Worksheet>"                                    & $CrLf
         Replace "*" With $Dq In sWorksheet

         sLayout = _
             IIf$( IsTrue(PageCenterHorizontal), "x:CenterHorizontal=*1*", "") & _ 
             IIf$(IsTrue(PageCenterVertical), " x:CenterVertical=*1*", "") & _
             IIf$(IsTrue(PageLandscape), " x:Orientation=*Landscape*", "") 
         If Len(sLayout) Then
            sLayout = "    <Layout " & sLayout & "/>" & $CrLf 
         End If
            
         sOptions = _
             " <WorksheetOptions xmlns=*urn:schemas-microsoft-com:office:excel*>" & $CrLf & _
             "   <PageSetup>" & $CrLf & _
             sLayout & _
             "    <Header x:Margin=*" & Format$(PageMarginHeader, "0.00") & "*/>" & $CrLf & _
             "    <Footer x:Margin=*" & Format$(PageMarginFooter, "0.00") & "*/>" & $CrLf & _
             "    <PageMargins x:Bottom=*" & Format$(PageMarginBottom, "0.00") & "* " & _
                              "x:Left=*"   & Format$(PageMarginLeft, "0.00")   & "* " & _
                              "x:Right=*"  & Format$(PageMarginRight, "0.00")  & "* " & _
                              "x:Top=*"    & Format$(PageMarginTop, "0.00")    & "*/>" & $CrLf & _
             "   </PageSetup>" & $CrLf & _                                 
             IIf$(FitToPage, "   <FitToPage/>" & $CrLf, "") & _
             "   <Unsynced/>"  & $CrLf & _
             "   <ProtectObjects>False</ProtectObjects>"     & $CrLf & _
             "   <ProtectScenarios>False</ProtectScenarios>" & $CrLf & _
             " </WorksheetOptions>" & $CrLf 
         Replace "*" With $Dq In sOptions
         Replace "//WORKSHEET_OPTIONS//" With sOptions In sWorksheet


         ' Add any columns that have had their widths manually set by the user
         For i = LBound(ColumnWidths) To UBound(ColumnWidths) 
            If ColumnWidths(i) > 0 Then
               st = st & _
                  "  <Column ss:Index=" & $Dq & Format$(i) & $Dq & _
                           " ss:Width=" & $Dq & Format$(ColumnWidths(i)) & $Dq & "/>" & $CrLf
            End If
         Next
         Replace "//COLUMN_WIDTHS//" With st In sWorksheet
         
         
         sRowMaster = _
            "  <Row//ROW_INDEX// ss:AutoFitHeight=*0*>"  & $CrLf & _
            "  //CELL_DATA//" & _
            "  </Row>"& $CrLf
         Replace "*" With $Dq In sRowMaster


         Local iStringRows As IStringBuilderA
         iStringRows = Class "StringBuilderA"
         iStringRows.Capacity = 1024 * 64   '(64K character buffer)

         Local iStringCells As IStringBuilderA
         iStringCells = Class "StringBuilderA"
         iStringCells.Capacity = 1024 * 64   '(64K character buffer)

         ' Iterate the rows collection and output the XML to the row
         If CellCount Then
            ' Must check CellCount because our arrays are initially dimmed at 0
            ' rather than 1. If no cells exist in worksheet then iCellIndex(1) would
            ' be an out of bounds condition.
            '
            ' Per the PB Help file, Array Sort does not work on arrays of interfaces. Seems
            ' like it fails on TagArray as well. We will create an index array and use
            ' that to reference our arrays.
            '
            ' This causes unpredictable results:
            ' Array Sort iCellIndex(1) For m_nCellCount, TagArray iCellArray()
            '
            Dim idx( 1 To CellCount) As Long
            For i = 1 To CellCount
               idx(i) = i
            Next   
            Array Sort iCellIndex(1) For CellCount, TagArray idx()

         End If

         
         nPrevRow = 0
         nPrevCol = 0
         IsLastRow = 0

         For i = 1 To CellCount 

            afxDoEvents(0)

            nCurRow  = Fix(iCellIndex(i) / 1000)
            nCurCol  = (iCellIndex(i) Mod 1000)

            ' Handle the special case where we are dealing with the last element
            ' in the array. Therefore we can't access the next higher element. 
            If i = CellCount Then
               IsLastRow = 1
            Else   
               nNextRow = Fix(iCellIndex(i+1) / 1000) 
            End If
            
            nRows = Max&(nRows, nCurRow)
            nCols = Max&(nCols, nCurCol+iCellArray(idx(i)).MergeAcross)

            If (nNextRow > nCurRow) Or (IsLastRow = 1) Then
               sRow = sRowMaster

               ' Only need to update the row index if the current row
               ' is not simply +1 higher than the previous row.
               If nCurRow > nPrevRow + 1  Then
                  Replace "//ROW_INDEX//" With " ss:Index=" & $Dq & Format$(nCurRow) & $Dq In sRow
               Else
                  Replace "//ROW_INDEX//" With "" In sRow
               End If
               
               st = iCellArray(idx(i)).ExcelCellXML( nPrevCol ) & $CrLf & "  "
               iStringCells.Add st

               Replace "//CELL_DATA//" With RTrim$(iStringCells.String) In sRow
               iStringRows.Add sRow
               nPrevRow = nCurRow
               nPrevCol = 0
               iStringCells.Clear
            
            Else
               st = iCellArray(idx(i)).ExcelCellXML( nPrevCol ) & $CrLf & "  "
               iStringCells.Add st
               nPrevCol = nCurCol
            End If
            
         Next


         Replace "//SHEET_NAME//"   With SheetName      In sWorksheet
         Replace "//COLUMN_COUNT//" With Format$(nCols) In sWorksheet
         Replace "//ROW_COUNT//"    With Format$(nRows) In sWorksheet
         Replace "//ALL_ROWS//"     With iStringRows.String In sWorksheet

         Let iStringRows  = Nothing
         Let iStringCells = Nothing

         Property = sWorkSheet

      End Property



   End Interface

End Class
