#Compile Exe


#Debug Error On
#Debug Display On

%TRUE  = 1
%FALSE = 0


#Link "xmlExcel.sll"


Function PBMain() As Long      


   ' Create some interface variables to handle our Workbook,
   ' Worksheets, and individual Cells.
   Local wb       As iExcelWorkBook
   Local ws       As iExcelWorkSheet
   Local iCell    As iExcelCell
   
   ' Create a Workbook class
   Let wb = Class "clsExcelWorkBook"

   ' Assign some Workbook info. This stuff is optional.
   wb.filename = "test.xml"
   wb.author   = "Paul Squires"
   wb.company  = "PlanetSquires"

   ' Retrieve the version number of this class library
   '? Str$(wb.version)

   ' Set some default font info that will apply to the 
   ' entire workbook. The defaults are:
   '   .FontName      = "Calibri"
   '   .FontSize      = 11
   '   .FontColor     = "#000000"   ' black
   ' Change our default font to Arial 10pt. This is optional.
   'wb.DefaultFontName = "Arial"
   'wb.DefaultFontSize = 10


   ' Add a worksheet and call it "Sheet1"
   Let ws = wb.AddWorkSheet("Sheet1")
   
   ' Set Column 4 to width 75.5 (in points)
   ' This class handles a maximum of *** 1000 columns ***.
   ws.SetColumnWidth 4, 75.5 

   ' Set some print parameters for this worksheet.
   ws.PageMarginHeader     = 0.5     ' default 0.3
   ws.PageMarginFooter     = 0.5     ' default 0.5
   'ws.PageMarginTop        = 0.75   ' default 0.75
   'ws.PageMarginLeft       = 0.7    ' default 0.7
   'ws.PageMarginRight      = 0.7    ' default 0.7
   'ws.PageMarginBottom     = 0.75   ' default 0.75
   ws.PageCenterVertical   = 1      ' default 0
   ws.PageCenterHorizontal = 1      ' default 0
   
   'ws.PagePortrait          = %FALSE
   ws.PageLandscape         = %TRUE
   'ws.FitToPage             = %TRUE
   
   ' Set the default row height (in points) for all rows in this Worksheet
   ws.DefaultRowHeight = 18   ' the default is 14.55 if not specified
   
   ' Individual cells are added using the .AddCell method of the
   ' Worksheet class. You pass the Row, Column, and Value to the
   ' method. The Value is a Variant so you can pass text and 
   ' numbers using the same .AddCell call.
   ' The .AddCell method returns a reference to the cell that is
   ' created. With that cell reference you can assign it different
   ' properties or simply do nothing and the default style for the
   ' workbook will be applied to it.
   ' The following creates a cell, assigns a Text value to it "Right"
   ' and then the alignment of the cell is set to AlignRight. Because
   ' no specific font was assigned to this cell, it will use the 
   ' default font for the Workbook.
   iCell = ws.AddCell( 1, 2, "Right" )
   iCell.AlignRight = %TRUE        
   
   ' There are many other cell properties that can be set. Here they are:
   ' FontName       As String
   ' FontSize       As Long
   ' FontBold       As Long     True/False
   ' FontItalic     As Long     True/False
   ' FontUnderline  As Long     True/False
   ' FontColor      As String   In the format #RRGGBB (hexadecimal values)
   ' CellColor      As String   In the format #RRGGBB (hexadecimal values)
   ' Format         As String   Date/Numeric formatting mask (see examples below)
   ' BorderLeft     As Long     True/False
   ' BorderTop      As Long     True/False
   ' BorderRight    As Long     True/False
   ' BorderBottom   As Long     True/False
   ' BorderColor    As String   In the format #RRGGBB (hexadecimal values)
   ' AlignLeft      As Long     True/False
   ' AlignRight     As Long     True/False
   ' AlignCenter    As Long     True/False
   ' Formula        As String   See examples below.
   ' MergeAcross    As Long     Span text across multiple columns (See examples below)
   ' WrapText       As Long     True/False.  Wrap long text within a cell.

   iCell = ws.AddCell( 3, 2, "Yellow!" )
   iCell.FontSize  = 10
   iCell.CellColor = "#FFFF00"

   iCell = ws.AddCell( 4, 2, "This is a very long string of text that should wrap." )
   iCell.FontSize  = 10
   iCell.WrapText  = %TRUE

   iCell = ws.AddCell( 5, 2, "Box" )
   iCell.BorderLeft   = %TRUE
   iCell.BorderTop    = %TRUE
   iCell.BorderRight  = %TRUE
   iCell.BorderBottom = %TRUE
   iCell.BorderColor  = "#FF0000"

   ' Merge/Span across 3 columns (4 total)
   iCell = ws.AddCell( 5, 5, "Span and Center" )
   iCell.MergeAcross = 3     ' cols 5,6,7,8 
   iCell.AlignCenter = %TRUE          
   iCell.FontColor   = "#FF0000"   'red
   iCell.CellColor   = "#AFEEEE"   'blue
   iCell.BorderBottom = %TRUE      ' no border color set so it will be black

   
   ' Add 3 values and then use a SUM formula to total them 
   iCell = ws.AddCell( 8, 1, 100 )
   iCell = ws.AddCell( 8, 2, 200 )
   iCell = ws.AddCell( 8, 3, 300 )

   iCell = ws.AddCell( 8, 4, 600 )
   iCell.Formula = "=SUM(RC[-3]:RC[-1])"
   iCell.Format  = "#,##0.00"
                          

   ' Add 3 values and then use a + formula to total them 
   iCell = ws.AddCell( 9, 1, 100 )
   iCell = ws.AddCell( 9, 2, 200 )
   iCell = ws.AddCell( 9, 3, 300 )

   iCell = ws.AddCell( 9, 4, 600 )
   iCell.Formula = "=RC[-3]+RC[-2]+RC[-1]"
   iCell.Format  = "#,##0.00"


   ' You can use the GetCell method to retrieve a reference to a
   ' cell object that you have already created in a worksheet.
   ' iCell = ws.GetCell( 8, 4 )
   ' MsgBox iCell.Formula


'd      Day of the month as digits without leading zeros for single-digit days.
'dd     Day of the month as digits with leading zeros for single-digit days.
'ddd    Abbreviated day Of the week As specified by a LOCALE_SABBREVDAYNAME* 
'       value, For example, "Mon" In English (United States).

'M      Month as digits without leading zeros for single-digit months.
'MM     Month as digits with leading zeros for single-digit months.
'MMM    Abbreviated month As specified by a LOCALE_SABBREVMONTHNAME* 
'       value, For example, "Nov" In English (United States).
'MMMM   Month as specified by a LOCALE_SMONTHNAME* value, for example, 
'       "November" for English (United States), and "Noviembre" for Spanish (Spain).

'y      Year represented only by the last digit.
'yy     Year represented only by the last two digits. A leading zero is 
'       added for single-digit years.
'yyyy   Year represented by a full four or five digits, depending On the 
'       calendar used. Thai Buddhist and Korean calendars have five-digit 
'       years. The "yyyy" pattern shows five digits for these two calendars, 
'       and four digits for all other supported calendars. Calendars that have 
'       single-digit or two-digit years, such as for the Japanese Emperor era, 
'       are represented differently. A single-digit year is represented with a 
'       leading zero, for example, "03". A two-digit year is represented with 
'       two digits, for example, "13". No additional leading zeros are displayed.

   ' Always enter the date text as yyyy-mm-dd when you are adding a
   ' new cell. You can format how that date will look when displayed in Excel.
   ' This class does not handle the Time portion of Dates. If there is a big
   ' demand for that ability then I'll add it.
   iCell = ws.AddCell( 11, 4, "2012-01-01" )
   iCell.Format = "MMM d, yyyy"
 
   

   ' Add another worksheet...
   Let ws = wb.AddWorkSheet("Sheet2")

   ' Add another worksheet...
   Let ws = wb.AddWorkSheet("Sheet3")

   ' Write our workbook to disk
   wb.WriteXML

   ' Clean up after ourselves
   Let iCell = Nothing
   Let ws = Nothing
   Let wb = Nothing

   ? "Done."

End Function
